;
; bat-ji
;
; Seⁿ bat-jī-khá
;
; Lûi Bêng-Hàn luibenghan@humanistic.org
;


(define (script-fu-bat-ji inFile inSave inCropX inCropY inCropWidth inCropHeight backColor textThau colorThau textSin colorSin textBoe colorBoe toaJi colorJi hoanHo)
(let*
(

	(srcImage	(car (gimp-file-load 1 inFile inFile ) ) )
	(srcLayer	(car (gimp-image-get-active-layer srcImage)))
	(destImage (car (gimp-image-new 3000 2000 0)))
	(destLayer (car (gimp-layer-new destImage 3000 2000 0 "default" 100 0 )))
	(pi-le)
	(geometryX)
	(geometryY)
	(jiX)
	(jiY)
	(boeX)
	(float-sel)
	(chiam-si)
)

	; copy lai-goan e tou
	(if (<= inCropWidth 0) (set! inCropWidth (car (gimp-drawable-width srcLayer))))
	(if (<= inCropHeight 0) (set! inCropHeight (car (gimp-drawable-height srcLayer))))
	(gimp-rect-select srcImage inCropX inCropY inCropWidth inCropHeight 2 0 0)
	(gimp-edit-copy srcLayer)

	; chun-pi beh oe e tou
	(gimp-image-add-layer destImage destLayer 0)
	(gimp-drawable-fill destLayer 2)

	; tah-tou
	(set! float-sel (car (gimp-edit-paste destLayer 0)))

	(if (> (/ inCropHeight inCropWidth) (/ 11 10)) 
		(begin
			(gimp-drawable-transform-scale float-sel 0 0 (- (/ (* inCropWidth 1650) inCropHeight) 1) 1649 0 2  1  3 0)
			(set! geometryX (car (gimp-drawable-width float-sel)))
			(set! geometryY (car (gimp-drawable-height float-sel)))
			(gimp-layer-set-offsets float-sel 
				(+ 1500 (/ (- 1500 geometryX) 2))
				0
			)
		)
	; else
		(begin
			(gimp-drawable-transform-scale float-sel 0 0 1499 (- (/ (* inCropHeight 1500) 1 inCropWidth) 1) 0 2  1  3 0)
			(set! geometryX (car (gimp-drawable-width float-sel)))
			(set! geometryY (car (gimp-drawable-height float-sel)))
			(gimp-layer-set-offsets float-sel 
				1500
				(/ (- 1500 geometryY) 2)
			)
		)
	)
	(gimp-floating-sel-anchor float-sel)

	; sia-ji
	;; Sng sou-u e ji u joa-tng
	(gimp-context-set-foreground  '(255 255 255))
	(set! chiam-si (string-append textSin textBoe))
	(if (> (string-length chiam-si) 0)
		(begin
			(set! float-sel (car (gimp-text-fontname destImage destLayer 1500 1500 chiam-si 0 1 200 0  "Charis SIL")))
			(set! boeX (car (gimp-drawable-width float-sel)))
			(gimp-edit-cut float-sel)
		)
	;else
		(set! boeX 0)
	)

	(set! chiam-si (string-append textThau chiam-si))
	(set! float-sel (car (gimp-text-fontname destImage destLayer 1500 1500 chiam-si 0 1 200 0  "Charis SIL")))
	(set! jiX (car (gimp-drawable-width float-sel)))
	(set! jiY (car (gimp-drawable-height float-sel)))
	(gimp-edit-cut float-sel)

	(if (< geometryY 1500)
		(set! geometryY (+ geometryY (/ (- 1500 geometryY) 2)))
	)
	(if (> (string-length textThau) 0)
		(begin
			(gimp-context-set-foreground  colorThau)
			(set! float-sel (car (gimp-text-fontname destImage destLayer 1500 1500 textThau 0 1 200 0  "Charis SIL")))
			(gimp-layer-set-offsets float-sel 
				(+ 1500 (/ (- 1500 jiX) 2))
				(+ geometryY (/ (- (- 2000 geometryY) jiY) 2))
			)
			(gimp-floating-sel-anchor float-sel)
		)
	)

	(if (> (string-length textBoe) 0)
		(begin
			(gimp-context-set-foreground  colorBoe)
			(set! float-sel (car (gimp-text-fontname destImage destLayer 1500 1500 textBoe 0 1 200 0  "Charis SIL")))
			(gimp-layer-set-offsets float-sel 
				(- (- 3000 (/ (- 1500 jiX) 2)) (car (gimp-drawable-width float-sel)) )
				(+ geometryY (/ (- (- 2000 geometryY) jiY) 2))
			)
			(gimp-floating-sel-anchor float-sel)
		)
	)

	(if (> (string-length textSin) 0)
		(begin
			(gimp-context-set-foreground  colorSin)
			(set! float-sel (car (gimp-text-fontname destImage destLayer 1500 1500 textSin 0 1 200 0  "Charis SIL")))
			(gimp-layer-set-offsets float-sel 
				(- (- 3000 (/ (- 1500 jiX) 2)) boeX)
				(+ geometryY (/ (- (- 2000 geometryY) jiY) 2))
			)
			(gimp-floating-sel-anchor float-sel)
		)
	)

	; au-piah-bin
	(gimp-rect-select destImage 0 0 1499 1999 2 0 0)
	(gimp-context-set-foreground  backColor)
	(gimp-edit-fill destLayer 0)
	
	; toa-ji
	(if (> (string-length toaJi) 0)
		(begin
			(gimp-context-set-foreground  colorJi)
			(set! float-sel (car (gimp-text-fontname destImage destLayer 1500 1500 toaJi 0 1 700 0  "Charis SIL")))
			(gimp-layer-set-offsets float-sel 
				(/ (- 1500 (car (gimp-drawable-width float-sel)) ) 2)
				(/ (- 2000 (car (gimp-drawable-height float-sel)) ) 2)
			)
			(gimp-floating-sel-anchor float-sel)
		)
	)

	; hoan-ho
	(if (> (string-length hoanHo) 0)
		(begin
			(gimp-context-set-foreground  '(0 0 0))
			(set! float-sel (car (gimp-text-fontname destImage destLayer 1500 1500 hoanHo 0 1 75 0  "Century Schoolbook L Bold")))
			(gimp-layer-set-offsets float-sel 
				(- 1450 (car (gimp-drawable-width float-sel)) )
				(- 1950 (car (gimp-drawable-height float-sel)) )
			)
			(gimp-floating-sel-anchor float-sel)
		)
	)
	
	; display our image:
	;(gimp-display-new destImage)
	(file-jpeg-save 1 destImage destLayer inSave inSave 0.95 0.1 1 0 inSave 0 0 0 0)
	(gimp-image-clean-all destImage)

)
)


; Register the function with the GIMP:

(script-fu-register
    "script-fu-bat-ji"
    "<Toolbox>/Xtns/Script-Fu/Text/Text Box"
    "sinn bat-ji-kah"
    "Michael Terry"
    "1997, Michael Terry"
    "October 27, 1997"
    ""
    SF-VALUE "Input File:"       "\"orig-a.jpg\""
    SF-VALUE "Output File:"       "\"new-a.jpg\""
    SF-VALUE "Crop xOffset:"       "440"
    SF-VALUE "Crop yOffset:"       "0"
    SF-VALUE "Crop Width:"       "1650"
    SF-VALUE "Crop Height:"       "1350"
    SF-COLOR "BG Color:" '(255 128 0)
    SF-VALUE "Thau Text:" "\"K\""
    SF-COLOR "Thau Color:" '(0 0 255)
    SF-VALUE "Sin Text:" "\"è-t\""
    SF-COLOR "Sin Color:" '(0 0 0)
    SF-VALUE "Boe Text:" "\"a̍t\""
    SF-COLOR "Boe Color:" '(255 0 0)
    SF-VALUE "Toa-ji:" "\"Chh\""
    SF-COLOR "Toa-ji:" '(0 0 0)
    SF-VALUE "Hoan-ho:" "\"17-04\""
)

; kha̍p


